#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <signal.h>
//#include <sys/cdio.h>
#include "darwin_cdio.h"

#include "bsd.h"
#include "taksignal.h"
#include "cdflags.h"
#include "config.h"

int play_track(int cdrom_fd,int track,int *seconds,time_t *starttime);
int stop_cd(int cdrom_fd);
int pause_cd(int cdrom_fd);
int resume_cd(int cdrom_fd,int *seconds,time_t starttime);

int play_track(int cdrom_fd,int track,int *seconds,time_t *starttime){
	int returnvalue=0;
	struct ioc_read_toc_entry toc;
	struct cd_toc_entry *entries;
	struct ioc_toc_header header;
	struct ioc_play_msf msf;
	int len,first,last;

	if(ioctl(cdrom_fd,CDIOREADTOCHEADER,(char*)&header)==-1)
		returnvalue=-1;

	else{
		first=header.starting_track;
		last=header.ending_track;
		len=(last-first+2)*sizeof(struct cd_toc_entry);

		entries=(struct cd_toc_entry*)malloc(len);

		toc.starting_track=0;
		toc.address_format=CD_MSF_FORMAT;
		toc.data_len=len;
		toc.data=entries;

		printf("Playing track %d\n",track);

		if((ioctl(cdrom_fd,CDIOREADTOCENTRYS,(char*)&toc))<0){
			fprintf(stderr,"Error reading table of contents\n");
			returnvalue=-1;
		}//if

/* Darwin doesn't appear to work too hard to support the use of CDIOCPLAYMSF
			msf.start_m=toc.data[track-1].addr.msf.minute;
			msf.start_s=toc.data[track-1].addr.msf.second;
			msf.start_f=toc.data[track-1].addr.msf.frame;

			msf.end_m=toc.data[track].addr.msf.minute;
			msf.end_s=toc.data[track].addr.msf.second;
			msf.end_f=toc.data[track].addr.msf.frame;

			(*seconds)=(msf.end_m-msf.start_m)*60+(msf.end_s-msf.start_s)+1;
*/
			(*starttime)=time(NULL);
		
			if(ioctl(cdrom_fd,CDIOCPLAYMSF,(char*)&msf)==-1){
				fprintf(stderr,"Error playing track %d\n",track);
				returnvalue=-1;
			}//if

			free(entries);

			printf("Track %d: %d seconds\n",track,*seconds);
		
			sleep(*seconds);
		}//else

	return returnvalue;
}//play_track



int stop_cd(int cdrom_fd){
	int returnvalue=0;

	if(ioctl(cdrom_fd,CDIOCSTOP,NULL)==-1){
		fprintf(stderr,"Error stopping CD\n");
		returnvalue=-1;
	}//if

	return returnvalue;
}//stop_cd
		

int resume_cd(int cdrom_fd, int *seconds, time_t starttime){
	int returnvalue=0;

	(*seconds)-=(int)(time(NULL)-starttime);
	if(ioctl(cdrom_fd,CDIOCRESUME,NULL)==-1){
		fprintf(stderr,"Error resuming cd play\n");
		returnvalue=-1;
	}//if
	else sleep(*seconds);
	
	return returnvalue;
}//resume_cd


int pause_cd(int cdrom_fd){
	int returnvalue=0;

	if(ioctl(cdrom_fd,CDIOCPAUSE,NULL)==-1)
		returnvalue=-1;

	pause();

	return returnvalue;
}//pause_cd
